﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WG_CheckBoxHeaderWithGroupByRows
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetUpGridDataSource();
            ultraGrid1.Rows.ExpandAll(true);
            CustomCreationFilter filter = new CustomCreationFilter("Check");
            ultraGrid1.CreationFilter = filter;
            filter.GroupByRowCheckBoxClicked += filter_GroupByRowCheckBoxClicked;
        }

        private void filter_GroupByRowCheckBoxClicked(object sender, GroupByRowCheckBoxClickedEventArgs e)
        {
         
            var cells = e.GroupByRow.Rows.Select(r => r.Cells["Check"]);
            bool isChecked = e.CheckBox.CheckState == CheckState.Checked ? true : false;
            foreach (var cell in cells)
            {
                cell.Value = isChecked;
            }
        }


        private void SetUpGridDataSource()
        {
            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));

            ds.Tables["table1"].Rows.Add(new Object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Appliances", 5, 90, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "FastFood", 20, 32, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Furniture", 12, 79, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Meat", 40, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Fruits", 25, 12, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Vegetables", 30, 13, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Cars", 13, 200, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Tools", 60, 15.3, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Estate", 5, 3000, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Motorcycles", 10, 320, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Clothes", 40, 69, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Shoes", 24, 40.6, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Games", 53, 50, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Books", 42, 22, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Movies", 38, 19, new DateTime(2009, 02, 28) });

            ultraGrid1.DataSource = ds;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var c = e.Layout.Bands[0].Columns.Add("Check");
            c.DataType = typeof(bool);
            c.Header.Caption = "";
            c.Header.CheckBoxAlignment = HeaderCheckBoxAlignment.Center ;
            c.Header.CheckBoxVisibility = HeaderCheckBoxVisibility.Always;
            c.Header.CheckBoxSynchronization = HeaderCheckBoxSynchronization.Band;
            e.Layout.Bands[0].SortedColumns.Add(c.Band.Columns["Date"], false, true);
        }
    }
}
